//+------------------------------------------------------------------+
//|                                                           rsioma |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers    4
#property indicator_color1     LimeGreen
#property indicator_color2     LimeGreen
#property indicator_color3     Red
#property indicator_color4     Red
#property indicator_width1     2
#property indicator_width2     2
#property indicator_width3     2
#property indicator_width4     2
#property indicator_levelcolor MediumOrchid

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    RsiPeriod       = 10;
extern int    Price           = PRICE_CLOSE;
extern int    SmoothType      = 2;
extern int    MaPeriod        = 10;
extern int    MaType          = MODE_LWMA;
extern double levelOb         = 0.70;
extern double levelOs         = -0.70;

extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alerts_On_Mobile       = false;
extern string soundFile       = "alert2.wav"; 

//
//
//
//
//

double iFish[];
double iFishua[];
double iFishub[];
double iFishda[];
double iFishdb[];
double rsi[];
double mab[];
double slope[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
    BuffersInit();
    IndicatorBuffers(8);
    SetIndexBuffer(0,iFish);
    SetIndexBuffer(1,iFishua); 
    SetIndexBuffer(2,iFishub); 
    SetIndexBuffer(3,iFishda); 
    SetIndexBuffer(4,iFishdb); 
    SetIndexBuffer(5,rsi);
    SetIndexBuffer(6,mab);
    SetIndexBuffer(7,slope);
    SetLevelValue(0,levelOs);
    SetLevelValue(1,levelOb);
    
       //
       //
       //
       //
       //
     
        indicatorFileName = WindowExpertName();
        calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
        returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
        timeFrame         = stringToTimeFrame(TimeFrame);
        
        string PriceType;
        switch(Price)
        {
           case PRICE_CLOSE:    PriceType = "Close";    break;  // 0
           case PRICE_OPEN:     PriceType = "Open";     break;  // 1
           case PRICE_HIGH:     PriceType = "High";     break;  // 2
           case PRICE_LOW:      PriceType = "Low";      break;  // 3
           case PRICE_MEDIAN:   PriceType = "Median";   break;  // 4
           case PRICE_TYPICAL:  PriceType = "Typical";  break;  // 5
           case PRICE_WEIGHTED: PriceType = "Weighted"; break;  // 6
        }      
        SmoothType  = MathMax(MathMin(SmoothType,14),0);
   IndicatorShortName(timeFrameToString(timeFrame)+"  Ift Rsi Gaussian Ma ("+RsiPeriod+","+MaPeriod+")");
return(0);
}

int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { iFish[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
     if (slope[limit] ==  1) ClearPoint(limit,iFishua,iFishub);
     if (slope[limit] == -1) ClearPoint(limit,iFishda,iFishdb);
     for (i=limit; i >= 0; i--) mab[i] = Smooth(SmoothType,Price,i);
     for (i=limit; i >= 0; i--) rsi[i] = 0.1*(iRSIOnArray(mab,0,RsiPeriod,i)-50);
     for (i=limit; i >= 0; i--)
     {
        double MA = iMAOnArray(rsi,0,MaPeriod,0,MaType,i);
         iFish[i] = (MathExp(2.0*MA)-1.0)/(MathExp(2.0*MA)+1.0);
            iFishua[i] = EMPTY_VALUE;
            iFishub[i] = EMPTY_VALUE;
            iFishda[i] = EMPTY_VALUE;
            iFishdb[i] = EMPTY_VALUE;
            slope[i]   = slope[i+1];
         
	         if (iFish[i] > iFish[i+1]) slope[i]= 1; 
	         if (iFish[i] < iFish[i+1]) slope[i]=-1;
	         if (slope[i] ==  1) PlotPoint(i,iFishua,iFishub,iFish);
            if (slope[i] == -1) PlotPoint(i,iFishda,iFishdb,iFish);
	       
     }
     manageAlerts();  
    return(0);
    }
    
    //
    //
    //
    //
    //
   
    limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
    if (slope[limit] ==  1) ClearPoint(limit,iFishua,iFishub);
    if (slope[limit] == -1) ClearPoint(limit,iFishda,iFishdb);
    for (i=limit;i>=0; i--)
    {
       int y = iBarShift(NULL,timeFrame,Time[i]);
            iFish[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiPeriod,Price,SmoothType,MaPeriod,MaType,0,y);
            slope[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiPeriod,Price,SmoothType,MaPeriod,MaType,7,y);  
            iFishua[i] = EMPTY_VALUE;
            iFishub[i] = EMPTY_VALUE;
            iFishda[i] = EMPTY_VALUE;
            iFishdb[i] = EMPTY_VALUE;
    }
      
    for (i=limit;i>=0;i--) 
    {
       if (slope[i] ==  1) PlotPoint(i,iFishua,iFishub,iFish);
       if (slope[i] == -1) PlotPoint(i,iFishda,iFishdb,iFish);
    }
    manageAlerts();
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define MaxLength 987
int    levels[] = {1,2,3,5,8,13,21,34,55,89,144,233,377,610,987};
double GaussianBuffer[][15];

//
//
//
//
//
//

double Gaussian(int Size, int X)
{
   return (MathExp(-X*X*9/((Size + 1)*(Size + 1))));
}

//
//
//
//
//

void BuffersInit()
{
   int i;
   
   ArrayResize(GaussianBuffer,MaxLength);
   for (int k = 0; k < 15; k++)
   {
      double sum = 0.0;
         for (i = 0; i < MaxLength; i++) { if (i>=levels[k]) break; GaussianBuffer[i][k]  = Gaussian(levels[k],i); sum += GaussianBuffer[i][k];}
         for (i = 0; i < MaxLength; i++) { if (i>=levels[k]) break; GaussianBuffer[i][k] /= sum; }
   }                              
}

//
//
//
//
//

double Smooth(int level,int appliedPrice, int shift)
{
   double sum   = 0;
   int    limit = levels[level];
   
   if (shift >= (Bars - limit)) return(iMA(NULL,0,1,0,MODE_SMA,appliedPrice,shift));
   
   //
   //
   //
   //
   //
   
   for (int i = 0; i < limit; i++)
           sum += GaussianBuffer[i][level]*iMA(NULL,0,1,0,MODE_SMA,appliedPrice,shift+i);
   return (sum);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
return(s);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void ClearPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
   {
      if (first[i+2] == EMPTY_VALUE) 
      {
          first[i]    = from[i];
          first[i+1]  = from[i+1];
          second[i]   = EMPTY_VALUE;
      }
      else
      {
          second[i]   = from[i];
          second[i+1] = from[i+1];
          first[i]    = EMPTY_VALUE;
      }
   }
   else
   {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}

//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (slope[whichBar] != slope[whichBar+1])
      {
         if (slope[whichBar] == 1) doAlert(whichBar,"up trend");
         if (slope[whichBar] ==-1) doAlert(whichBar,"down trend");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" ift rsi gaussian ",doWhat);
          if (alertsMessage) Alert(message);
          
          if (alerts_On_Mobile)   SendNotification(message);
          if (alertsSound)   PlaySound(soundFile);
   }
}





